Redmine - Feature #15361

Use css pseudo-classes instead of cycle("odd", "even")
2013-11-1511:15 - Vadim Pushtaev

Status: Closed Start date:

Priority: Normal Due date:

Assignee: Jean-Philippe Lang % Done: 0%
Category: Code cleanup/refactoring Estimated time: 0.00 hour
Target version: 3.4.0

Resolution: Fixed

Description

I'm not sure it's a right way to ask such questions, so I'm sorry in advance.
I'm trying to produce some solution for making drag'n'drop in tables possible (see #12909).
| have a problem with class="<%= cycle("odd", "even") %>">, static classes are not suitable for drag'n'drop.

What do you think about using :0dd and :even css pseudo-classes just to avoid static classes? | can make a patch, but will it be
accepted?

Associated revisions

Revision 16050 - 2016-12-03 10:15 - Jean-Philippe Lang

Use css pseudo-classes instead "odd", "even" classes (#15361).
Patch by Marius BALTEANU.

Revision 16051 - 2016-12-03 10:21 - Jean-Philippe Lang

Removes calls to #reset_cycle (#15361).

Revision 16052 - 2016-12-03 10:59 - Jean-Philippe Lang
Reverts r16051 and r16050 for now (#15361).

Revision 16249 - 2017-01-25 12:44 - Jean-Philippe Lang
Use css pseudo-classes instead of cycle("odd", "even") (#15361).
Patch by Marius BALTEANU.

Revision 16250 - 2017-01-25 12:45 - Jean-Philippe Lang

Fixes row background for alternate theme (#15361).

Revision 16259 - 2017-01-25 17:11 - Jean-Philippe Lang

Remove background on subtasks and relations introduced in r16249 (#15361).

Revision 16262 - 2017-01-26 19:07 - Jean-Philippe Lang

Adds odd_even class to time entries (#15361).

Patch by Marius BALTEANU.

History

#1 - 2013-11-15 20:42 - Jean-Philippe Lang

You should be able to reassign the appropriate css class to each row after drag'n'drop easily using javascript. But using pseudo-classes seems an
interesting option to clean up the views.

#2 - 2013-11-15 20:44 - Jean-Philippe Lang
- Tracker changed from Defect to Feature

- Subject changed from cycle("odd", "even") instead of css pseudo-classes to Use css pseudo-classes instead of cycle("odd", "even")
- Category set to Code cleanup/refactoring

#3 - 2016-05-31 00:49 - Marius BALTEANU

- File use_pseudo_classes.patch added

I've created a patch that replaces the cycle("odd", "even") with CSS pseudo-classes. The patch passes the tests.
Some remarks regarding this patch:

1. In current version, roadmap and version pages don't have the odd/even classes, but with this patch will have the styles (which is good for
consistency in my opinion).

2. To keep the current style of block "Spent Time" from My Page (total row with "odd" style and time entries with white background), it was required
to add two new CSS rules to specifically target that rows.

3. For drag'n'drop feature (Redmine 3.3.0 #12909) it is no longer required to recalculate the odd/even classes using JS.

#4 - 2016-05-31 02:48 - Go MAEDA

- Target version set to Candidate for next major release

Although the patch may break some themes, it makes view files cleaner and can save some processor cycles on web servers.

#5 - 2016-06-09 16:50 - Go MAEDA

- Target version changed from Candidate for next major release to 3.4.0

#6 - 2016-08-23 00:30 - Marius BALTEANU

- File use_pseudo_classes_v2.patch added

Updated the patch to cleanly apply on the current trunk and also to include the new "cycle("odd", "even")" added in r15466

#7 - 2016-12-03 10:40 - Jean-Philippe Lang

I've committed the patch but it comes with an undesirable change: when displaying issue descriptions on the issue list, we used to get the issue row
and its description with the same background color. Now, the issue and the description have their own background with different colors. It kind of
breaks the readability of the list. Not sure if we can fix it using CSS only.

#8 - 2016-12-03 10:54 - Marius BALTEANU

Jean-Philippe Lang wrote:

I've committed the patch but it comes with an undesirable change: when displaying issue descriptions on the issue list, we used to get the issue
row and its description with the same background color. Now, the issue and the description have their own background with different colors. It
kind of breaks the readability of the list. Not sure if we can fix it using CSS only.

I'll come up with a solution to fix this issue.

#9 - 2016-12-03 11:01 - Jean-Philippe Lang
Themes that colorize issues based on odd/even classes will have to get fixed (including the "alternate" theme provided with the core). Is the removal
of 2 javascript lines worth this pain? | mean, what is the real benefit of using the CSS pseudo classes?

#10 - 2016-12-03 11:02 - Jean-Philippe Lang

FTR, I've reverted the changes until we find a solution for note-7 and take the decision to integrate the change.

#11 - 2016-12-06 00:09 - Marius BALTEANU
- File issues_list.png added
- File 3.4.0_use_pseudo_classes_v3.patch added

I've attached a new patch that fixes the issue from note-7. The patch includes both revisions (r16050 and r16051).
issues_list.png
The simplest solution found was to keep the odd/even classes in the "issues/_list.html.erb" and "timelogs/_list.html.erb" views. The fix required also to
have a new class named "odd-even" for the tables that still use the odd/even classes.

#12 - 2016-12-06 00:22 - Marius BALTEANU

Jean-Philippe Lang wrote:
Themes that colorize issues based on odd/even classes will have to get fixed (including the "alternate" theme provided with the core). Is the
removal of 2 javascript lines worth this pain? | mean, what is the real benefit of using the CSS pseudo classes?

The new patch solves also the "alternate" theme. For other themes, the required fix is very small.
Regarding the real benefits, from my point of view:

- cleaner view files
- using a native and client-side only solution instead one that requires server-side processing and client-side

- simple way to style the tables (if you have a simple table, you only need the "list" class on the table; if you have a more complex table and you want

to control the odd and even rows, you need the "list odd-even" classes and the "cycle" implementation).

For us, this feature is not a big improvement because in our custom theme we use the same color for rows and a bottom border as delimiter.

#13 - 2017-01-25 12:47 - Jean-Philippe Lang
- Status changed from New to Closed
- Assignee set to Jean-Philippe Lang

- Resolution set to Fixed

Patch is committed, thanks Marius. | still had to fix the backgrounds for the alternate theme.

#14 - 2017-01-25 13:05 - Marius BALTEANU

Jean-Philippe Lang wrote:

Patch is committed, thanks Marius. | still had to fix the backgrounds for the alternate theme.

I'm sure that | looked into the problem. I'll apply again the patch without your fix to understand what was the problem. Thanks.

#15 - 2017-01-25 20:53 - Marius BALTEANU

- File add_odd-even_class_to_time_entries_block_from_my page.patch added

| still can't figure it out which was the problem with the alternate theme, | miss something, for sure. But is not so important.

r16249 adds the :not(.odd-even) to the respective selectors and make them more powerfull than the rule "div.mypage-box table.time-entries
tr.time-entry". The attached patch fixes the issue generated by that change and keeps the current style of the block "Spent Time" from My Page.

#16 - 2017-01-26 02:00 - Go MAEDA

- Status changed from Closed to Reopened

Reopening to handle #15361#note-15.

#17 - 2017-01-26 19:07 - Jean-Philippe Lang

- Status changed from Reopened to Closed

Patch applied, thanks.

Files

use_pseudo_classes.patch 27.6 KB 2016-05-30 Marius BALTEANU
use_pseudo_classes_v2.patch 28.3 KB 2016-08-22 Marius BALTEANU
issues_list.png 81.2KB 2016-12-05 Marius BALTEANU
3.4.0_use_pseudo_classes_v3.patch 29.4 KB 2016-12-05 Marius BALTEANU
add_odd-even_class_to_time_entries_block_from_my_page.patch 1.38 KB 2017-01-25 Marius BALTEANU
